## unbound 1.0.2

=== doc/requirements.txt ===
Requirements for Recursive Caching Resolver 
	(a.k.a. Treeshrew, Unbound-C)
By W.C.A. Wijngaards, NLnet Labs, October 2006.

Contents
1. Introduction
2. History
3. Goals
4. Non-Goals


1. Introduction
---------------
This is the requirements document for a DNS name server and aims to
document the goals and non-goals of the project.  The DNS (the Domain
Name System) is a global, replicated database that uses a hierarchical
structure for queries.

Data in the DNS is stored in Resource Record sets (RR sets), and has a
time to live (TTL).  During this time the data can be cached.  It is
thus useful to cache data to speed up future lookups.  A server that
looks up data in the DNS for clients and caches previous answers to
speed up processing is called a caching, recursive nameserver.  

This project aims to develop such a nameserver in modular components, so
that also DNSSEC (secure DNS) validation and stub-resolvers (that do not
run as a server, but a linked into an application) are easily possible.

The main components are the Validator that validates the security
fingerprints on data sets, the Iterator that sends queries to the
hierarchical DNS servers that own the data and the Cache that stores
data from previous queries.  The networking and query management code
then interface with the modules to perform the necessary processing.

In Section 2 the origins of the Unbound project are documented. Section
3 lists the goals, while Section 4 lists the explicit non-goals of the
project. Section 5 discusses choices made during development.


2. History
----------
The unbound resolver project started by Bill Manning, David Blacka, and
Matt Larson (from the University of California and from Verisign), that
created a Java based prototype resolver called Unbound.  The basic
design decisions of clean modules was executed.

The Java prototype worked very well, with contributions from Geoff
Sisson and Roy Arends from Nominet.  Around 2006 the idea came to create
a full-fledged C implementation ready for deployed use.  NLnet Labs
volunteered to write this implementation.


3. Goals
--------
o A validating recursive DNS resolver.
o Code diversity in the DNS resolver monoculture.
o Drop-in replacement for BIND apart from config.
o DNSSEC support.
o Fully RFC compliant.
o High performance
	* even with validation.
o Used as
	* stub resolver.
	* full caching name server.
	* resolver library.
o Elegant design of validator, resolver, cache modules.
	* provide the ability to pick and choose modules.
o Robust.
o In C, open source: The BSD license. 
o Highly portable, targets include modern Unix systems, such as *BSD,
solaris, linux, and maybe also the windows platform.
o Smallest as possible component that does the job.
o Stub-zones can be configured (local data or AS112 zones).


4. Non-Goals
------------
o An authoritative name server.
o Too many Features.


5. Choices
----------
o rfc2181 decourages duplicates RRs in RRsets. unbound does not create
  duplicates, but when presented with duplicates on the wire from the
  authoritative servers, does not perform duplicate removal.
  It does do some rrsig duplicate removal, in the msgparser, for dnssec qtype
  rrsig and any, because of special rrsig processing in the msgparser.
o The harden-glue feature, when yes all out of zone glue is deleted, when
  no out of zone glue is used for further resolving, is more complicated 
  than that, see below.
  Main points:
  	* rfc2182 trust handling is used. 
	* data is let through only in very specific cases
	* spoofability remains possible.
  Not all glue is let through (despite the name of the option). Only glue 
  which is present in a delegation, of type A and AAAA, where the name is
  present in the NS record in the authority section is let through.
  The glue that is let through is stored in the cache (marked as 'from the
  additional section'). And will then be used for sending queries to. It
  will not be present in the reply to the client (if RD is off).
  A direct query for that name will attempt to get a msg into the message
  cache. Since A and AAAA queries are not synthesized by the unbound cache,
  this query will be (eventually) sent to the authoritative server and its
  answer will be put in the cache, marked as 'from the answer section' and
  thus remove the 'from the additional section' data, and this record is 
  returned to the client.
  The message has a TTL smaller or equal to the TTL of the answer RR.
  If the cache memory is low; the answer RR may be dropped, and a glue
  RR may be inserted, within the message TTL time, and thus return the
  spoofed glue to a client. When the message expires, it is refetched and
  the cached RR is updated with the correct content.
  The server can be spoofed by getting it to visit a especially prepared 
  domain. This domain then inserts an address for another authoritative 
  server into the cache, when visiting that other domain, this address may
  then be used to send queries to. And fake answers may be returned.
  If the other domain is signed by DNSSEC, the fakes will be detected.

  In summary, the harden glue feature presents a security risk if
  disabled. Disabling the feature leads to possible better performance
  as more glue is present for the recursive service to use. The feature
  is implemented so as to minimise the security risk, while trying to 
  keep this performance gain.
o The method by which dnssec-lameness is detected is not secure. DNSSEC lame
  is when a server has the zone in question, but lacks dnssec data, such as
  signatures. The method to detect dnssec lameness looks at nonvalidated 
  data from the parent of a zone. This can be used, by spoofing the parent,
  to create a false sense of dnssec-lameness in the child, or a false sense
  or dnssec-non-lameness in the child. The first results in the server marked
  lame, and not used for 900 seconds, and the second will result in a 
  validator failure (SERVFAIL again), when the query is validated later on.

  Concluding, a spoof of the parent delegation can be used for many cases
  of denial of service. I.e. a completely different NS set could be returned,
  or the information withheld. All of these alterations can be caught by
  the validator if the parent is signed, and result in 900 seconds bogus. 
  The dnssec-lameness detection is used to detect operator failures, 
  before the validator will properly verify the messages.

  Also for zones for which no chain of trust exists, but a DS is given by the
  parent, dnssec-lameness detection enables. This delivers dnssec to our 
  clients when possible (for client validators).

  The following issue needs to be resolved:
	a server that serves both a parent and child zone, where
	parent is signed, but child is not. The server must not be marked 
	lame for the parent zone, because the child answer is not signed. 
  Instead of a false positive, we want false negatives; failure to 
  detect dnssec-lameness is less of a problem than marking honest 
  servers lame. dnssec-lameness is a config error and deserves the trouble.
  So, only messages that identify the zone are used to mark the zone
  lame. The zone is identified by SOA or NS RRsets in the answer/auth.
  That includes almost all negative responses and also A, AAAA qtypes.
  That would be most responses from servers.
  For referrals, delegations that add a single label can be checked to be
  from their zone, this covers most delegation-centric zones.

  So possibly, for complicated setups, with multiple (parent-child) zones 
  on a server, dnssec-lameness detection does not work - no dnssec-lameness 
  is detected. Instead the zone that is dnssec-lame becomes bogus.

o authority features.
  This is a recursive server, and authority features are out of scope.
  However, some authority features are expected in a recursor. Things like
  localhost, reverse lookup for 127.0.0.1, or blocking AS112 traffic.
  Also redirection of domain names with fixed data is needed by service
  providers. Limited support is added specifically to address this.

  Adding full authority support, requires much more code, and more complex
  maintenance.

  The limited support allows adding some static data (for localhost and so),
  and to respond with a fixed rcode (NXDOMAIN) for domains (such as AS112).

  You can put authority data on a separate server, and set the server in 
  unbound.conf as stub for those zones, this allows clients to access data 
  from the server without making unbound authoritative for the zones.

o the access control denies queries before any other processing.
  This denies queries that are not authoritative, or version.bind, or any.
  And thus prevents cache-snooping (denied hosts cannot make non-recursive
  queries and get answers from the cache).

o If a client makes a query without RD bit, in the case of a returned 
  message from cache which is:
	answer section: empty
	auth section: NS record present, no SOA record, no DS record, 
		maybe NSEC or NSEC3 records present.
	additional: A records or other relevant records.
  A SOA record would indicate that this was a NODATA answer.
  A DS records would indicate a referral.
  Absence of NS record would indicate a NODATA answer as well.

  Then the receiver does not know whether this was a referral
  with attempt at no-DS proof) or a nodata answer with attempt
  at no-data proof. It could be determined by attempting to prove
  either condition; and looking if only one is valid, but both 
  proofs could be valid, or neither could be valid, which creates
  doubt. This case is validated by unbound as a 'referral' which
  ascertains that RRSIGs are OK (and not omitted), but does not
  check NSEC/NSEC3. 

o Case preservation
  Unbound preserves the casing received from authority servers as best 
  as possible. It compresses without case, so case can get lost there.
  The casing from the query name is used in preference to the casing
  of the authority server. This is the same as BIND. RFC4343 allows either 
  behaviour.

## unbound 1.3.4

=== doc/requirements.txt ===
--- 
+++ 
@@ -206,3 +206,33 @@
   The casing from the query name is used in preference to the casing
   of the authority server. This is the same as BIND. RFC4343 allows either 
   behaviour.
+ 
+o Denial of service protection
+  If many queries are made, and they are made to names for which the
+  authority servers do not respond, then the requestlist for unbound
+  fills up fast.  This results in denial of service for new queries.
+  To combat this the first 50% of the requestlist can run to completion.
+  The last 50% of the requestlist get (200 msec) at least and are replaced
+  by newer queries when older (LIFO).
+  When a new query comes in, and a place in the first 50% is available, this
+  is preferred.  Otherwise, it can replace older queries out of the last 50%.
+  Thus, even long queries get a 50% chance to be resolved.  And many 'short'
+  one or two round-trip resolves can be done in the last 50% of the list.
+  The timeout can be configured.
+
+o EDNS fallback. Is done according to the EDNS RFC (and update draft-00).
+  Unbound assumes EDNS 0 support for the first query.  Then it can detect
+  support (if the servers replies) or non-support (on a NOTIMPL or FORMERR).
+  Some middleboxes drop EDNS 0 queries, mainly when forwarding, not when
+  routing packets.  To detect this, when timeouts keep happening, as the
+  timeout approached 5-10 seconds, and EDNS status has not been detected yet,
+  a single probe query is sent.  This probe has a sub-second timeout, and
+  if the server responds (quickly) without EDNS, this is cached for 15 min.
+  This works very well when detecting an address that you use much - like
+  a forwarder address - which is where the middleboxes need to be detected.
+  Otherwise, it results in a 5 second wait time before EDNS timeout is 
+  detected, which is slow but it works at least. 
+  It minimizes the chances of a dropped query making a (DNSSEC) EDNS server
+  falsely EDNS-nonsupporting, and thus DNSSEC-bogus, works well with 
+  middleboxes, and can detect the occasional authority that drops EDNS.
+  For some boxes it is necessary to probe for every failing query, a

=== pythonmod/Makefile ===
# Makefile: tests unbound python module (please edit SCRIPT variable)
#
# Copyright (c) 2009, Zdenek Vasicek (vasicek AT fit.vutbr.cz)
#                     Marek Vavrusa  (xvavru00 AT stud.fit.vutbr.cz)
#
# This software is open source.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    * Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
# 
#    * Redistributions in binary form must reproduce the above copyright notice,
#      this list of conditions and the following disclaimer in the documentation
#      and/or other materials provided with the distribution.
# 
#    * Neither the name of the organization nor the names of its
#      contributors may be used to endorse or promote products derived from this
#      software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

SUEXEC  = sudo
UNBOUND = ../unbound
SCRIPT  = ./test-dict.conf

UNBOUND_OPTS = -dv -c $(SCRIPT)

.PHONY: test sudo suexec doc

all: test

$(UNBOUND):
	make -C ..

test: $(UNBOUND)
	$(UNBOUND) $(UNBOUND_OPTS)

sudo: $(UNBOUND)
	sudo $(UNBOUND) $(UNBOUND_OPTS)

suexec: $(UNBOUND)
	su -c "$(UNBOUND) $(UNBOUND_OPTS)"

doc:
	$(MAKE) -C doc html

## unbound 1.4.1

=== libunbound/python/Makefile ===
#
# Makefile: compilation of pyUnbound and documentation, testing
#
# Copyright (c) 2009, Zdenek Vasicek (vasicek AT fit.vutbr.cz)
#                     Marek Vavrusa  (xvavru00 AT stud.fit.vutbr.cz)
#
# This software is open source.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    * Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
# 
#    * Redistributions in binary form must reproduce the above copyright notice,
#      this list of conditions and the following disclaimer in the documentation
#      and/or other materials provided with the distribution.
# 
#    * Neither the name of the organization nor the names of its
#      contributors may be used to endorse or promote products derived from this
#      software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  testenv   to make test environment and run bash "
	@echo "            usefull in case you don't want to install unbound but want to test examples"
	@echo "  doc       to make documentation"
	@echo "  clean     clean all"

.PHONY: testenv clean doc swig

#_unbound.so:	../../Makefile
	#$(MAKE) -C ../..

#../../.libs/libunbound.so.0:	../../Makefile
	#$(MAKE) -C ../..

#../../ldns-src/lib/libldns.so:	../../ldns-src/Makefile
	#$(MAKE) -C ../../ldns-src

clean:
	rm -rdf examples/unbound
	rm -f _unbound.so libunbound_wrap.o
	$(MAKE) -C ../.. clean

testenv: ../../.libs/libunbound.so.1 ../../ldns-src/lib/libldns.so ../../.libs/_unbound.so
	rm -rdf examples/unbound
	cd examples && mkdir unbound && ln -s ../../unbound.py unbound/__init__.py && ln -s ../../_unbound.so unbound/_unbound.so && ln -s ../../../../.libs/libunbound.so.1 unbound/libunbound.so.1 && ln -s ../../../../ldns-src/lib/libldns.so.1 unbound/libldns.so.1 && ls -la
	cd examples && if test -f ../../../.libs/_unbound.so; then cp ../../../.libs/_unbound.so . ; fi
	@echo "Run a script by typing ./script_name.py"
	cd examples && LD_LIBRARY_PATH=unbound bash
	rm -rdf examples/unbound examples/_unbound.so

doc: ../../.libs/libunbound.so.0 _unbound.so
	$(MAKE) -C docs html

#for development only
swig: libunbound.i 
	swig -python -o libunbound_wrap.c -I../.. libunbound.i
	gcc -c libunbound_wrap.c -O9 -fPIC -I../.. -I/usr/include/python2.5 -I. -o libunbound_wrap.o
	gcc -shared libunbound_wrap.o -L../../.libs -lunbound -o _unbound.so

## unbound 1.4.5-0maemo0~devel1~svn2115

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2115) fremantle; urgency=low

  * dh_makeshlibs breaks on Maemo autobuilder, works in local SDK
  * debug: disable dh_makeshlibs, works in local SDK, see what breaks it
    * without makeshlibs, shlibdeps doesn't find libunbound2
    * added static deps
    * test with mockup next
  * note to self: changing targets:
    *  make realclean; svn update; dpkg-buildpackage

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 22 May 2010 00:01:00 +0200

unbound (1.4.5-0maemo0~devel~svn2115) fremantle; urgency=low

  ** 21 May 2010: Wouter
        - EDNS timeout code will not fire if EDNS status already known.
        - EDNS failure not stored if EDNS status known to work.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 22 May 2010 00:00:00 +0200

unbound (1.4.5-0~ppa~lampe1+svn2114) unstable; urgency=low

  ** 9 May 2010: Wouter
        - Fix resolution for domains like safesvc.com.cn.  If the iterator
          can not recurse further and it finds the delegation in a state
          where it would otherwise have rejected it outhand if so received
          from a cache lookup, then it can try to ask higherup (with loop
          protection).
        - Fix comments in iter_utils:dp_is_useless.

  ** 18 May 2010: Wouter
        - Fix various compiler warnings from the clang llvm compiler.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 19 May 2010 00:00:00 +0200

unbound (1.4.5-0~ppa~lampe1+svn2110) unstable; urgency=low

  * svn rev. 2110

 -- Hauke Lampe <lampe@hauke-lampe.de>  Tue, 11 May 2010 00:00:00 +0200

## unbound 1.4.5-0maemo0~devel1~svn2119

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2119) fremantle; urgency=low

  ** 28 May 2010: Wouter
        - iana portlist updated.
        - parent-child disagreement approach altered.  Older fixes are
          removed in place of a more exhaustive search for misconfigured data
          available via the parent of a delegation.
          This is designed to be throttled by cache entries, with TTL from the
          parent if possible.  Additionally the loop-counter is used.
          It also tests for NS RRset differences between parent and child.
          The fetch of misconfigured data should be more reliable and thorough.
          It should work reliably even with no or only partial data in cache.
          Data received from the child (as always) is deemed more
          authoritative than information received from the delegation parent.
          The search for misconfigured data is not performed normally.

  ** 26 May 2010: Wouter
        - Contribution from Migiel de Vos (Surfnet): nagios patch for
          unbound-host, in contrib/ (in the source tarball).  Makes
          unbound-host suitable for monitoring dnssec(-chain) status.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Fri, 28 May 2010 00:00:00 +0200

## unbound 1.4.5-0maemo0~devel1~svn2129

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2129) fremantle; urgency=low

  ** 1 June 2010: Wouter
        - Ignore Z flag in incoming messages too.
        - Fix storage of negative parent glue if that last resort fails.
        - libtoolize 2.2.6b, autoconf 2.65 applied to configure.
        - new splint flags for newer splint install.

  ** 31 May 2010: Wouter
        - Fix AD flag handling, it could in some cases mistakenly copy the AD 
          flag from upstream servers.
        - alloc_special_obtain out of memory is not a fatal error any more,
          enabling unbound to continue longer in out of memory conditions.
        - parentside names are dispreferred but not said to be dnssec-lame.
        - parentside check for cached newname glue.
        - fix parentside and querytargets modulestate, for dump_requestlist.
        - unbound-control-setup makes keys -rw-r--- so not all users permitted.
        - fix parentside from cache to be marked dispreferred for bad names.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Tue, 01 Jun 2010 00:00:00 +0200

## unbound 1.4.5-0maemo0~devel1~svn2143

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2143) fremantle; urgency=low

  ** 4 June 2010: Wouter
        - iana portlist updated.
        - 1.4.5rc1 tag created.

  ** 3 June 2010: Wouter
        - ldns tarball updated, 1.6.5.
        - review comments, split dependency cycle tracking for parentside
          last resort lookups for A and AAAA so there are more lookup options.

  ** 2 June 2010: Wouter
        - Fix compile warning if compiled without threads.
        - updated ldns-tarball with current ldns svn (pre 1.6.5).
        - GOST disabled-by-default, the algorithm number is allocated but the
          RFC is still has to pass AUTH48 at the IETF.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Fri, 04 Jun 2010 00:00:00 +0200

## unbound 1.4.5-0maemo0~devel1~svn2144

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2144) fremantle; urgency=low

  ** 10 June 2010: Wouter
        - Fix bug where a long loop could be entered, now cycle detection
          has a loop-counter and maximum search amount.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Thu, 10 Jun 2010 00:00:00 +0200

## unbound 1.4.5-0maemo0~devel1~svn2146

=== debian/changelog ===
unbound (1.4.5-0maemo0~devel1~svn2146) fremantle; urgency=low

  ** 11 June 2010: Wouter
        - When retry to parent the retrycount is not wiped, so failed 
          nameservers are not tried again.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 12 Jun 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2153

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2153) fremantle; urgency=low

  ** 15 June 2010: Wouter
        - Fix TCPreply on systems with no writev, if just 1 byte could be sent.
        - Fix to use one pointer less for iterator query state store_parent_NS.
        - makedist crosscompile to windows uses builtin ldns not host ldns.
        - Max referral count from 30 to 130, because 128 one character domains
          is valid DNS.
        - added documentation for the histogram printout to syslog.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Tue, 15 Jun 2010 00:01:00 +0200

unbound (1.4.5-0maemo0) fremantle; urgency=low

  ** 15 June 2010: Wouter
        - tag 1.4.5 created.
        - trunk contains 1.4.6 in development.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Tue, 15 Jun 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2156

=== contrib/python/Makefile ===
# Makefile: compilation of sources and documentation, test environment
#
# Copyright (c) 2009, Zdenek Vasicek (vasicek AT fit.vutbr.cz)
#                     Karel Slany    (slany AT fit.vutbr.cz)
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#       this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the organization nor the names of its
#       contributors may be used to endorse or promote products derived from this
#       software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  testenv   to make test environment and run bash "
	@echo "            usefull in case you don't want to install ldns but want to test examples"
	@echo "  doc       to make documentation"
	@echo "  clean     clean all"

../../Makefile: ../../configure
	cd ../.. && ./configure --with-python
	
_ldns.so:	../../Makefile
	$(MAKE) -C ../..

../../.libs/ldns.so.1:	../../Makefile
	$(MAKE) -C ../..

clean:
	rm -rdf examples/ldns
	rm -f _ldns.so ldns_wrapper.o
	$(MAKE) -C ../.. clean

testenv: ../../.libs/libldns.so.1 _ldns.so
	rm -rdf examples/ldns
	cd examples && mkdir ldns && ln -s ../../ldns.py ldns/__init__.py && ln -s ../../_ldns.so ldns/_ldns.so && ln -s ../../../../.libs/libldns.so.1 ldns/libldns.so.1 && ls -la
	@echo "Run a script by typing ./script_name.py"
	cd examples && LD_LIBRARY_PATH=ldns bash
	rm -rdf examples/ldns

doc: ../../.libs/ldns.so.1 _ldns.so
	$(MAKE) -C docs html

#for development only
swig: ldns.i
	swig -python -o ldns_wrapper.c -I../.. ldns.i
	gcc -c ldns_wrapper.c -O9 -fPIC -I../.. -I../../ldns -I/usr/include/python2.5 -I. -o ldns_wrapper.o
	ld -shared ldns_wrapper.o -L../../.libs -lldns -o _ldns.so

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2156) fremantle; urgency=low

  ** 16 June 2010: Wouter
        - Fix assertion failure reported by Kai Storbeck from XS4ALL, the
          assertion was wrong.
        - updated ldns tarball.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 16 Jun 2010 00:00:00 +0200

=== debian/control ===
Source: unbound
Section: net
Priority: extra
Maintainer: Hauke Lampe <lampe@hauke-lampe.de>
Build-Depends: debhelper (>= 5), autotools-dev, libssl-dev, bison
Standards-Version: 3.7.2

Package: unbound
Section: net
Architecture: any
Depends: libc6 (>= 2.5.0-1), libssl0.9.8 (>= 0.9.8f-5), passwd
Description: validating, recursive, caching DNS resolver
 Unbound is a recursive-only caching DNS server which can optionally
 perform DNSSEC validation of results. It implements only a minimum amount
 of authoritative service to prevent leakage to the root nameservers:
 forward lookups for localhost, reverse for 127.0.0.1 and ::1, and
 NXDOMAIN for zones served by AS112. Stub and forward zones are supported.
 .
 Unbound implements a number of security features, including chrooting and
 privilege dropping.
 .
 This package contains the unbound daemon.
 .
 Default configuration modified for reduced memory usage. DNSSEC validation is
 not enabled by default but can be activated in /etc/unbound/unbound.conf.
 Unbound does NOT use your ISPs DNS proxies in the standard configuration.
 Instead, it resolves names iteratively up from the DNS root zone.
 .
 WARNING: This package is not for end-users. You SHOULD know what you're
 doing. You need to manually deactivate dnsmasq in /etc/event.d/ and
 know how to get it running again. This package does NOT use chroot.

Package: unbound-dbg
Architecture: any
Depends: unbound (= ${binary:Version})
Suggests: gdb
Priority: extra
Section: debug
Description: Debug symbols for Unbound
 This package provides the debugging symbols for Unbound.
 Those symbols allow your debugger to assign names to your backtraces, which
 makes it somewhat easier to interpret core dumps.

Package: unbound-host
Section: net
Architecture: any
Depends: libc6 (>= 2.5.0-1), libssl0.9.8 (>= 0.9.8f-5), libunbound2
Description: reimplementation of the 'host' command
 This package provides the 'unbound-host' program that is bundled with the
 Unbound domain name server. This version differs from the one provided in the
 package called host, which is from NIKHEF, and bind9-host, which is from ISC,
 and has a similar but different set of features/options.

Package: unbound-tools
Section: net
Architecture: any
Depends: libc6 (>= 2.5.0-1), libssl0.9.8 (>= 0.9.8f-5)
Description: Tools for controlling the Unbound daemon
 This package contains unbound-control and unbound-checkconf

Package: libunbound2
Section: libs
Architecture: any
Depends: libc6 (>= 2.5.0-1), libssl0.9.8 (>= 0.9.8f-5)
Description: library implementing DNS resolution and validation
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back, and obtain other information from the
 DNS. Public-key validation of results is performed with DNSSEC.

Package: libunbound-dev
Section: libdevel
Architecture: any
Depends: libunbound2 (= ${binary:Version})
Description: static library, header files, and docs for libunbound
 Static library, header files, and documentation for libunbound.
 .
 libunbound performs and validates DNS lookups; it can be used to convert
 hostnames to IP addresses and back, and obtain other information from the
 DNS. Public-key validation of results is performed with DNSSEC.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs" \
		--disable-rpath \
		--with-chroot-dir=/var/lib/unbound \
		--with-pidfile=/var/lib/unbound/unbound.pid \
		--with-conf-file=/etc/unbound/unbound.conf \
		--with-ssl \
		--with-ldns-builtin

#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp:  config.status

	# Add here commands to compile the arch part of the package.
	#$(MAKE) 
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:  config.status

	# Add here commands to compile the indep part of the package.
	#$(MAKE) doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i

	# Add here commands to install the indep part of the package into
	# debian/<package>-doc.
	#INSTALLDOC#

	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s 
	dh_installdirs -s

	# Add here commands to install the arch part of the package into 
	# debian/tmp.
	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	dh_install -s
# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
#	dh_installchangelogs 
#	dh_installdocs
	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip -a --dbg-package=unbound-dbg || dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
## DEBUG: dpkg-gensymbols breaks in Maemo-Autobuilder, not in local SDK
## try disabling first
#	dh_makeshlibs
	dh_installdeb
## DEBUG: without symbols, dh_shlibdeps does not find libunbound2
## added static deps
#	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch

## unbound 1.4.6-0maemo0~devel1~svn2169

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2169) fremantle; urgency=low

  ** 25 June 2010: Wouter
        - Fix handling of corner case reply from lame server, follows rfc2308.
          It could lead to a nodata reply getting into the cache if the search
          for a non-lame server turned up other misconfigured servers.
        - unbound.h has extern "C" statement for easier include in c++.

  ** 23 June 2010: Wouter
        - iana portlist updated.
        - makedist upgraded cross compile openssl option, like this: 
          ./makedist.sh -s -wssl openssl-1.0.0a.tar.gz -w --enable-gost

  ** 22 June 2010: Wouter
        - Unbound reports libev or libevent correctly in logs in verbose mode.
        - Fix to unload gost dynamic library module for leak testing.

  ** 18 June 2010: Wouter
        - iana portlist updated.

  ** 17 June 2010: Wouter
        - Add AAAA to root hints for I.ROOT-SERVERS.NET.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 26 Jun 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2171

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2171) fremantle; urgency=low

  ** 28 June 2010: Wouter
        - Fix jostle list bug found by Vince (luoce@cnnic), it caused the qps
          in overload situations to be about 5 qps for the class of shortly
          serviced queries.
          The capacity of the resolver is then about (numqueriesperthread / 2)
          / (average time for such long queries) qps for long queries.
          And about (numqueriesperthread / 2)/(jostletimeout in whole seconds)
          qps for short queries, per thread.
        - Fix the max number of reply-address count to be applied for duplicate
          queries, and not for new query list entries.  This raises the memory
          usage to a max of (16+1)*numqueriesperthread reply addresses.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 30 Jun 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2173

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2173) fremantle; urgency=low

  ** 1 July 2010: Wouter
        - Fix RFC4035 compliance with 2.2 statement that the DNSKEY at apex
          must be signed with all algorithms from the DS rrset at the parent.
          This is now checked and becomes bogus if not.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Fri, 02 Jul 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2190

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2190) fremantle; urgency=low

  ** 10 July 2010: Wouter
        - GOST enabled if SSL is recent and ldns has GOST enabled too.
        - ldns tarball updated.

  ** 9 July 2010: Wouter
        - iana portlist updated.
        - Fix validation of qtype DNSKEY when a key-cache entry exists but
          no rr-cache entry is used (it expired or prefetch), it then goes
          back up to the DS or trust-anchor to validate the DNSKEY.

  ** 7 July 2010: Wouter
        - Neat function prototypes, unshadowed local declarations.

  ** 6 July 2010: Wouter
        - failure to chown the pidfile is not fatal any more.
        - testbound uses UTC timezone.
        - ldns tarball updated (ports and works on Minix 3.1.7).  On Minix, add
          /usr/gnu/bin to PATH, use ./configure AR=/usr/gnu/bin/gar and gmake.

  ** 5 July 2010: Wouter
        - log if a server is skipped because it is on the donotquery list,
          at verbosity 4, to enable diagnosis why no queries to 127.0.0.1.
        - added feature to print configure date, target and options with -h.
        - added feature to print event backend system details with -h.
        - wdiff is not actually required by make test, updated requirements.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sun, 11 Jul 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2198

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2198) fremantle; urgency=low

  ** 14 July 2010: Wouter
        - Donation text added to README.
        - Fix integer underflow in prefetch ttl creation from cache.  This
          fixes a potential negative prefetch ttl.

  ** 12 July 2010: Wouter
        - Changed the defaults for num-queries-per-thread/outgoing-range.
          For builtin-select: 512/960, for libevent 1024/4096 and for
          windows 24/48 (because of win api).  This makes the ratio this way
          to improve resilience under heavy load.  For high performance, use
          libevent and possibly higher numbers.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 14 Jul 2010 00:00:00 +0200

## unbound 1.4.6-0maemo0~devel1~svn2201

=== debian/changelog ===
unbound (1.4.6-0maemo0~devel1~svn2201) fremantle; urgency=low

  ** 22 July 2010: Wouter
        - more error details on failed remote control connection.

  ** 15 July 2010: Wouter
        - rlimit adjustments for select and ulimit can happen at the same time.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Mon, 26 Jul 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2212

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2212) fremantle; urgency=low

  ** 13 August 2010: Wouter
        - More pleasant remote control command parsing.
        - documentation added for return values reported by doxygen 1.7.1.
        - iana portlist updated.

  ** 9 August 2010: Wouter
        - Fix name of rrset printed that failed validation.

  ** 5 August 2010: Wouter
        - Return NXDOMAIN after chain of CNAMEs ends at name-not-found.

  ** 4 August 2010: Wouter
        - Fix validation in case a trust anchor enters into a zone with
          unsupported algorithms.

  ** 3 August 2010: Wouter
        - updated ldns tarball with bugfixes.
        - release tag 1.4.6.
        - trunk becomes 1.4.7 develop.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 14 Aug 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2221

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2221) fremantle; urgency=low

  ** 19 August 2010: Wouter
        - Fix bug#321: resolution of rs.ripe.net artifacts with 0x20.
          Delegpt structures checked for duplicates always.
          No more nameserver lookups generated when depth is full anyway.
        - example.conf notes how to do DNSSEC validation and track the root.
        - iana portlist updated.

  ** 18 August 2010: Wouter
        - Fix bug#322: configure does not respect CFLAGS on Solaris.
          Pass CFLAGS="-xO4 -xtarget=generic" on the configure command line
          if use sun-cc, but some systems need different flags.

  ** 16 August 2010: Wouter
        - Fix acx_nlnetlabs.m4 configure output for autoconf-2.66 AS_TR_CPP
          changes, uses m4_bpatsubst now.
        - make test (or make check) should be more portable and run the unit 
          test and testbound scripts. (make longtest has special requirements).

 -- Hauke Lampe <lampe@hauke-lampe.de>  Fri, 20 Aug 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2224

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2224) fremantle; urgency=low

  ** 20 August 2010: Wouter
        - openbsd-lint fixes: acl_list_get_mem used if debug-alloc enabled.
          iterator get_mem includes priv_get_mem.  delegpt nodup removed.
          listen_pushback, query_info_allocqname, write_socket, send_packet,
          comm_point_set_cb_arg and listen_resume removed.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 21 Aug 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2227

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2227) fremantle; urgency=low

  ** 9 September 2010: Wouter
        - unresponsive servers are not completely blacklisted (because of
          firewalls), but also not probed all the time (because of the request
          list size it generates).  The probe rate is 1%.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sat, 11 Sep 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2228

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2228) fremantle; urgency=low

  ** 13 September 2010: Wouter
        - bug#327: Fix for cannot access stub zones until the root is primed.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Mon, 13 Sep 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2234

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2234) fremantle; urgency=low

  ** 15 September 2010: Wouter
        - Abide RFC5155 section 9.2: no AD flag for replies with NSEC3 optout.

  ** 14 September 2010: Wouter
        - increased mesh-max-activation from 1000 to 3000 for crazy domains
          like _tcp.slb.com with 262 servers.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Thu, 16 Sep 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2239

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2239) fremantle; urgency=low

  ** 17 September 2010: Wouter
        - DLV has downgrade protection again, because the RFC says so.
        - iana portlist updated.

  ** 16 September 2010: Wouter
        - Algorithm rollover operational reality intrudes, for trust-anchor,
          5011-store, and DLV-anchor if one key matches it's good enough.
        - iana portlist updated.
        - Fix reported validation error in out of memory condition.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Sun, 19 Sep 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2277

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2277) fremantle; urgency=low

  * added unbound-anchor to package unbound-tools

  ** 11 October 2010: Wouter
        - Fix bug when DLV below a trust-anchor that uses NSEC3 optout where
          the zone has a secure delegation hosted on the same server did not
          verify as secure (it was insecure by mistake).
        - iana portlist updated.
        - ldns tarball updated (for reading cachedumps with bad RR data).

  ** 1 October 2010: Wouter
        - test for unbound-anchor. fix for reading certs.
        - Fix alloc_reg_release for longer uptime in out of memory conditions.

  ** 28 September 2010: Wouter
        - unbound-anchor working, it creates or updates a root.key file.
          Use it before you start the validator (e.g. at system boot time).

  ** 27 September 2010: Wouter
        - iana portlist updated.

  ** 24 September 2010: Wouter
        - bug#329: in example.conf show correct ipv4 link-local 169.254/16.

  ** 23 September 2010: Wouter
        - unbound-anchor app, unbound requires libexpat (xml parser library).

  ** 22 September 2010: Wouter
        - compliance with draft-ietf-dnsop-default-local-zones-14, removed
          reverse ipv6 orchid prefix from builtin list.
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Mon, 11 Oct 2010 00:00:00 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: extra
 Maintainer: Hauke Lampe <lampe@hauke-lampe.de>
-Build-Depends: debhelper (>= 5), autotools-dev, libssl-dev, bison
+Build-Depends: debhelper (>= 5), autotools-dev, libssl-dev, bison, libexpat1-dev
 Standards-Version: 3.7.2
 
 Package: unbound
@@ -56,7 +56,10 @@
 Architecture: any
 Depends: libc6 (>= 2.5.0-1), libssl0.9.8 (>= 0.9.8f-5)
 Description: Tools for controlling the Unbound daemon
- This package contains unbound-control and unbound-checkconf
+ This package provides supplemental tools for Unbound:
+ unbound-control, unbound-control-setup
+ unbound-checkconf
+ unbound-anchor
 
 Package: libunbound2
 Section: libs

## unbound 1.4.7-0maemo0~devel1~svn2282

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2282) fremantle; urgency=low

  * added missing symlink for unbound-anchor
  * added libexpat1 to unbound-tool dependencies

  ** 13 October 2010: Wouter
        - Fix TCP so it uses a random outgoing-interface.
        - unbound-anchor handles ADDPEND keystate.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 13 Oct 2010 00:00:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2286

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2286) fremantle; urgency=low

  * re-upload, auto-builder failed to deploy package

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 13 Oct 2010 00:01:00 +0200

## unbound 1.4.7-0maemo0~devel1~svn2302

=== debian/changelog ===
unbound (1.4.7-0maemo0~devel1~svn2302) fremantle; urgency=low

  ** 20 October 2010: Wouter
        - interface automatic works for some people with ip6 disabled.
          Therefore the error check is removed, so they can use the option.

  ** 19 October 2010: Wouter
        - Fix for request list growth, if a server has long timeout but the
          lost counter is low, then its effective rtt is the one without
          exponential backoff applied.  Because the backoff is not working.
          The lost counter can then increase and the server is blacklisted,
          or the lost counter does not increase and the server is working
          for some queries.

  ** 18 October 2010: Wouter
        - iana portlist updated.

 -- Hauke Lampe <lampe@hauke-lampe.de>  Wed, 20 Oct 2010 00:00:00 +0200
